//
// Ludumdare 48h #22 gamedev entry by Jere "XMunkki" Sanisalo
// 17.12.2011 - 19.12.2011
//
// Licenced undel the GPLv2.
// Some base code used from http://processingjs.org/learning/custom/snake
//
int SMENU = 0;
int SGAME = 1;
int ABLOCK = 0;
int AKILL = 1;
int ACONVERT = 2;
int screen_mode = SMENU;
    
int max_pts = 400;
float[] snake_x = new float[max_pts];
float[] snake_y = new float[max_pts];
float[] snake_ox = new float[max_pts];
float[] snake_oy = new float[max_pts];
int snake_pts = max_pts;
float snake_red_pos = (float)snake_pts;
float snake_red_pos_vis = snake_red_pos;
float seg_length = 10.f;
float end_timer = 0.f;
int max_areas = 100;
float[] area_x = new float[max_areas];
float[] area_y = new float[max_areas];
float[] area_rad = new float[max_areas];
float[] area_time = new float[max_areas];
float[] area_param = new float[max_areas];
int[] area_type = new int[max_areas];
int area_cnt = 0;
int score = 0;
int hiscore = 0;
void setup()
{
    size(640, 400);
    smooth();
    start_menu();
//    start_game();
}
void draw()
{
    if (screen_mode == SMENU)
        draw_menu();
    else if (screen_mode == SGAME)
        draw_game();
}
void mouseClicked()
{
    if (screen_mode == SMENU)
        start_game();
}
void start_menu()
{
    screen_mode = SMENU;
}
void write(String txt, float x, float y)
{
    noStroke();
    fill(0, 0, 0, 255);
    text(txt, x + 1, y + 1);
    fill(235, 245, 250, 255);
    text(txt, x, y);
}
void draw_menu()
{
    background(86);
    int y = 30;
    int h = 14;
    write("Friendship Snake", 30, y); y += h;
    y += h;
    write("The red power of loneliness is starting to take over.", 30, y);  y += h;
    write("The guide the the snake to the green emblems of enlightenment.", 30, y);  y += h;
    y += h;
    write("Don't let doubt into your heart..", 30, y);  y += h;
    y += h;
    y += h;
    y += h;
    y += h;
    y += h;
    write("Hiscore: " + hiscore, 30, y);  y += h;
    y += h;
    write("Click mouse to start, move mouse to guide the snake..", 30, y);  y += h;
    
    y = height - h * 4;
    write("Ludumdare 48h #22 gamedev entry by Jere \"XMunkki\" Sanisalo", 30, y);  y += h;
    write("http://www.xmunkki.org/", 30, y);  y += h;
}
void start_game()
{
    // Init the snake
    snake_pts = max_pts;
    for (int i = 0; i < snake_pts; ++i)
    {
        float a = (float)i * 0.12f;
        float r = 30.f + (float)(snake_pts - i) * 1.5f;
        float x = (width * 0.5f) + (cos(a) * r);
        float y = (height * 0.5f) + (sin(a) * r);
        snake_x[i] = snake_ox[i] = x;
        snake_y[i] = snake_oy[i] = y;
    }
    
    // Init the scoring
    snake_pts = 4;
    snake_red_pos = (float)(snake_pts + 1);
    snake_red_pos_vis = snake_red_pos;
    score = 0;
    end_timer = 0.f;
    
    // Init the areas
    area_cnt = 0;
    
    screen_mode = SGAME;
}
void draw_game()
{
    float delta_t = 1.f / 60.f;
    // Add new areas?
    {
        int cnt_block = 0;
        int cnt_kill = 0;
        int cnt_convert = 0;
        
        for (int i = 0; i < area_cnt; ++i)
        {
            int atype = area_type[i];
            if (atype == ABLOCK)
                ++cnt_block;
            else if (atype == AKILL)
                ++cnt_kill;
            else if (atype == ACONVERT)
                ++cnt_convert;
        }
        
        int kill_target =
            (int)constrain(
                (float)snake_pts / 10.f,
                0, 20);
        int convert_target =
            (int)constrain(
                (float)snake_pts / 60.f,
                1, 2);
        
        while (cnt_block < 10) { add_area(ABLOCK); ++cnt_block; }
        while (cnt_kill < kill_target) { add_area(AKILL); ++cnt_kill; }
        while (cnt_convert < convert_target) { add_area(ACONVERT); ++cnt_convert; }
    }
    
    // Area update
    {
        int pos = 0;
        while (pos < area_cnt)
        {
            bool done = false;
            area_time[pos] += delta_t;
            
            //if (area_type[pos] == ABLOCK || area_type[pos] == AKILL)
            {
                float rel = area_time[pos] / 10.f;
                if (rel < 0.f)
                    area_rad[pos] = 0.f;
                else
                    area_rad[pos] =
                        pow(sin(rel * PI), 0.2f) *
                        area_param[pos];
                done = (rel >= 1.f);
            }
            
            // Next
            if (done)
                remove_area(pos);
            else
                ++pos;
        }
    }
    
    // Extend the red area
    float red_speed = max(-1.f + (float)snake_pts * 0.3f, 0.f);
    snake_red_pos -= delta_t * red_speed;
    
    snake_red_pos_vis = lerp(snake_red_pos_vis, snake_red_pos, 0.2f);
    
    // Follow the mouse
    {
        float dx = (mouseX - snake_x[0]);
        float dy = (mouseY - snake_y[0]);
        float max_delta = 200.f;
        float dlen = sqrt(dx * dx + dy * dy);
        if (dlen > max_delta)
        {
            float dmul = max_delta / dlen;
            dx *= dmul; dy *= dmul;
        }
        
        snake_ox[0] = snake_x[0] - dx;
        snake_oy[0] = snake_y[0] - dy;
    }
    
    // Satisfy the area constraints
//    do_area_constraints();
    
    // Integrate the positions
    for(int i=0; i < snake_pts; i++)
    {
        integrate(i, (i == 0) ? 0.2f : 0.f);
    }
    
    // Satisfy the area constraints
//    do_area_constraints();
    
    // Satisfy the snake constraints
    for (int i=4; i < snake_pts; ++i)
    {
        line_constraint(i - 4, i, 0.f, 1.f, seg_length * 4.f);
    }
    for (int i=1; i < snake_pts; ++i)
    {
        line_constraint(i - 1, i, 0.f, 1.f, seg_length);
    }
    // Satisfy the area constraints (again)
    do_area_constraints();
    
    background(86);
    
    // Draw the head + body
    for(int i = snake_pts - 1; i >= 1; --i)
    {
        dragSegment(i, snake_x[i - 1], snake_y[i - 1]);
    }
    
    dragSegment(
        0,
        snake_x[0] + (snake_x[0]-snake_x[1]),
        snake_y[0] + (snake_y[0]-snake_y[1]));
        
/*    for(int i = 1; i < snake_pts; i++)
    {
        dragSegment(i, snake_x[i - 1], snake_y[i - 1]);
    }*/
    
    // Draw the areas
    for (int i = 0; i < area_cnt; ++i)
    {
        float r = area_rad[i];
        int t = area_type[i];
        
        noStroke();
        if (t == ABLOCK)
            fill(200, 200, 200, 255);
        else if (t == AKILL)
            fill(255, 20, 40, 255);
        else if (t == ACONVERT)
            fill(80, 255, 40, 255);
        
        ellipse(
            area_x[i], 
            area_y[i],
            r * 2.f,
            r * 2.f);
    }
    // Write the score
    write("Score: " + score, 10, 20);
    // Game over?
    if (snake_red_pos < 0.f &&
        snake_red_pos_vis < 0.f)
    {
        end_timer += delta_t;
        if (end_timer > 0.5f)
            start_menu();
    }
    else
    {
        end_timer = 0.f;
    }
}
// Satisfies area constraints
void do_area_constraints()
{
    int collect_idx = -1;
    
    for (int i = 0; i < snake_pts; i++)
    {
        for (int j = 0; j < area_cnt; ++j)
        {
            int atype = area_type[j];
            
            bool hit = dist_constraint(
                i, 
                area_x[j], area_y[j], area_rad[j] + 5.f,
                false);
            if (hit && i == 0)
            {
                if ((atype == AKILL && area_time[j] >= 1.f) ||
                    (atype == ACONVERT))
                {
                    collect_idx = j;
                }
            }
        }
    }
    // Collected?
    if (collect_idx >= 0)
    {
        int atype = area_type[collect_idx];
        remove_area(collect_idx);
        
        if (atype == AKILL)
        {
            snake_red_pos -= (float)snake_pts * 0.5f;
        }
        else if (atype == ACONVERT)
        {
            if (snake_pts < max_pts)
            { // Add a new snake piece
                float dx = snake_x[snake_pts - 2] - snake_x[snake_pts - 1];
                float dy = snake_y[snake_pts - 2] - snake_y[snake_pts - 1];
                snake_x[snake_pts] = snake_x[snake_pts - 1] - dx;
                snake_y[snake_pts] = snake_y[snake_pts - 1] - dy;
                snake_ox[snake_pts] = snake_x[snake_pts - 1];
                snake_oy[snake_pts] = snake_y[snake_pts - 1];
            }
            snake_pts = min(snake_pts + 1, max_pts);
            snake_red_pos = (float)(snake_pts + 1);
            snake_red_pos_vis += 1.f;
        
            ++score;
            if (score > hiscore)
                hiscore = score;
        }
    }
}
// Verlet integration
void integrate(int i, float vel_mul)
{
    float _x = snake_x[i];
    float _y = snake_y[i];
    float dx = _x - snake_ox[i];
    float dy = _y - snake_oy[i];
    snake_x[i] += dx * vel_mul; snake_y[i] += dy * vel_mul;
    snake_ox[i] = _x; snake_oy[i] = _y;
}
// Point distance constraint
bool dist_constraint(
    int i,
    float px, float py,
    float prad,
    bool dont_fix_pos)
{
    float dx = snake_x[i] - px;
    float dy = snake_y[i] - py;
    float dlen2 = dx * dx + dy * dy;
    
    if (prad < 0.01f || dlen2 > (prad * prad))
        return false;
    
    if (dlen2 > 0.1f && !dont_fix_pos)
    {
        // Project the position to the sphere
        float dmul = prad / sqrt(dlen2);
        snake_x[i] = px + dx * dmul;
        snake_y[i] = py + dy * dmul;
    }
    
    return true;
}
// Line distance constraint
void line_constraint(
    int i1, int i2,
    float inv_mass1, float inv_mass2,
    float rest_dist)
{
    float rd2 = rest_dist * rest_dist;
    
    float dx = snake_x[i2] - snake_x[i1];
    float dy = snake_y[i2] - snake_y[i1];
    float dlen = sqrt(dx * dx + dy * dy);
    if (dlen < 0.0001f)
        return;
    float diff = (rest_dist - dlen) / (dlen);
    diff /= inv_mass1 + inv_mass2;
    dx *= diff; dy *= diff;
    
    snake_x[i1] -= inv_mass1 * dx; snake_y[i1] -= inv_mass1 * dy;
    snake_x[i2] += inv_mass2 * dx; snake_y[i2] += inv_mass2 * dy;
}
void dragSegment(int i, float xin, float yin)
{
    float dx = xin - snake_x[i];
    float dy = yin - snake_y[i];
    float dist = sqrt(dx*dx + dy*dy);
    float angle = atan2(dy, dx);
//    stroke(23, 79, 4, 220);
  
    pushMatrix();
    translate(snake_x[i], snake_y[i]);
    rotate(angle);
  
    color c;
    bool is_red = (i >= (int)snake_red_pos_vis);
    if (is_red)
    {
        if (i % 3 == 1)
            c = color(215, 100, 60, 255);
        else if (i % 3 == 2)
            c = color(235, 50, 30, 255);
        else
            c = color(255, 0, 0, 255);
    }
    else
    {
        if (i % 3 == 1)
            c = color(100, 215, 60, 255);
        else if (i % 3 == 2)
            c = color(50, 235, 30, 255);
        else
            c = color(0, 255, 0, 255);
    }
    stroke( c );
    strokeWeight(10);
    line(0, 0, dist, 0);
  
  if (i == snake_pts - 1)
  {
    fill( c );
    noStroke();
    beginShape(TRIANGLES);
    vertex(0, 5);
    vertex(-2 * seg_length, 0);
    vertex(0, -5);
    endShape();
  }
  
  if ( i == 0 )
  {
   // stroke(0, 255);
   noStroke();
   fill(0, 255);
   ellipse(seg_length, -2, 3, 3);
   ellipse(seg_length, 2, 3, 3);
    //point(seg_length, -2);
    //point(seg_length, 2);
  }
  
  popMatrix();
}
void add_area(int atype)
{
    if (area_cnt >= max_areas)
        return;
        
    float border = 0.f;
    float time = 0.f;
    float param = 0.f;
    float rad = 0.f;
        
    //if (atype == ABLOCK)
    {
        time = random(-4.f, 0.f);
        param = random(20, 70);
    }
    if (atype == AKILL || atype == ACONVERT)
    {
        time = 0.f;
        param = random(71, 80);
    }
    area_x[area_cnt] = random(border, width - border);
    area_y[area_cnt] = random(border, height - border);
    area_time[area_cnt] = time;
    area_param[area_cnt] = param;
    area_rad[area_cnt] = rad;
    area_type[area_cnt] = atype;
    ++area_cnt;
}
void remove_area(int idx)
{
    --area_cnt;
    while (idx < area_cnt)
    {
        area_x[idx] = area_x[idx + 1];
        area_y[idx] = area_y[idx + 1];
        area_time[idx] = area_time[idx + 1];
        area_param[idx] = area_param[idx + 1];
        area_rad[idx] = area_rad[idx + 1];
        area_type[idx] = area_type[idx + 1];
        ++idx;
    }
}
